#include"utils.h"
#include"MiModelo.h"

MiModelo::MiModelo(void)
	: BaseModel(2)
{
	g=9.8;
	L=0.1;
	beta=0.001;
	m=0.1;
	State(0)=0.0;
	State(1)=35.0;
}

Vector MiModelo::Evaluate(const Vector &state,double t) const
{
	double theta=state[0];
	double omega=state[1];
	Vector dot_state(2);
	dot_state[0]=omega;
	dot_state[1]=-g/L*sin(theta)-beta/(m*L*L)*omega;
	return dot_state;
}

void MiAnimacion::Output(void)
{
    theta=Simulation()->ModelP()->State(0);
    t=Simulation()->Time();
}

void MiAnimacion::InitDrawing(void)
{
    Glib::RefPtr<Gdk::Colormap> colormap = get_default_colormap ();
	blue = Gdk::Color("blue");
	green = Gdk::Color("PaleGreen");
	colormap->alloc_color(blue);
	colormap->alloc_color(green);
	
	Glib::RefPtr<Gdk::Window> window = get_window();
	gc = Gdk::GC::create(window);
	window->set_background(green);
	window->clear();
	gc->set_foreground(blue);
}

void MiAnimacion::Draw(void)
{
    const int x0=100;
	const int y0=100;
	const int r=10;
	const int L=75;
	Glib::RefPtr<Gdk::Window> window = get_window();
	int x=int(L*sin(theta));
	int y=int(L*cos(theta));
	window->clear();
	window->draw_line(gc, x0, y0, x0+x, y0+y);  	 
	window->draw_arc(gc,true,x0-r+x,y0-r+y,2*r,2*r,0,360*64);
	Glib::RefPtr<Pango::Layout> layout=Gtk::Widget::create_pango_layout("t="+MakeString(t)); 
	window->draw_layout(gc,0,0,layout);
}

RTGSimulation* CrearAnimacion(void)
{
    RTGSimulation *animacion=new MiAnimacion;
    animacion->Configure(new MiModelo,0.01);
    return animacion;
}
