#include<math.h>
#include"utils.h"
#include"MiModelo.h"
#include"RTGSimulation.h"
using namespace std;

RTGSimulation::RTGSimulation(void)
{
    modelsim=NULL;
}

RTGSimulation::~RTGSimulation(void)
{
    Stop();
    delete modelsim;
}

void RTGSimulation::Configure(Model *m,double delta_t)
{
    Stop();
    delete modelsim;
    modelsim=new RKModelSimulation(m,delta_t);
    Output();
	update=false;
}

void RTGSimulation::Start(void)
{
    if(modelsim)
        Timer::Start(modelsim->SamplePeriod());
}

void RTGSimulation::Execute(void)
{
    modelsim->Step();
	gdk_threads_enter();
    Output();
	if(!update) {
        update=true;               
	    queue_draw();
     }
	gdk_threads_leave();
}

void RTGSimulation::on_realize()
{
    Gtk::DrawingArea::on_realize();
	InitDrawing();
}

bool RTGSimulation::on_expose_event(GdkEventExpose* /*e*/)
{
	Draw();
	update=false;
	return true;
}

const ModelSimulation* RTGSimulation::Simulation(void) const
{
    return modelsim;
}


