#include"Timer.h"

#if defined(__WIN32__)

void CALLBACK TimerAuxFunc(UINT uID, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2)
{
    Timer *timer=reinterpret_cast<Timer*>(dwUser);
    timer->Execute();
}

Timer::Timer(void)
{
    started=false;
}

Timer::~Timer(void)
{
    Stop();	
}

void Timer::Start(double period)
{
     timerID=timeSetEvent((UINT)(period*1000),0,TimerAuxFunc,(DWORD)this,TIME_PERIODIC);
     started=true;
}

void Timer::Stop(void)
{
    if(started) {
        started=false;
        timeKillEvent(timerID);
    }
}

#elif defined(__linux__)

void TimerAuxFunc(sigval_t sigval)
{
    Timer *timer=reinterpret_cast<Timer*>(sigval.sival_ptr);
    timer->Execute();
}

Timer::Timer(void)
{
    evp.sigev_notify=SIGEV_THREAD;
    evp.sigev_signo=69;
    evp.sigev_value.sival_ptr=reinterpret_cast<void*>(this);
    evp.sigev_notify_function=TimerAuxFunc;
    evp.sigev_notify_attributes=NULL;
    started=false;
}

Timer::~Timer(void)
{
    Stop();	
}

void Timer::Start(double period)
{
    timer_create(CLOCK_MONOTONIC,&evp,&tim);
    its.it_value.tv_sec=0;
    its.it_value.tv_nsec=1;
    its.it_interval.tv_sec=int(period);
    its.it_interval.tv_nsec=int((period-int(period))*1e9);
    timer_settime(tim,0,&its,NULL);
    started=true;
}

void Timer::Stop(void)
{
    if(started) {
        started=false;
        timer_delete(tim);
    }
}

#endif
