#ifndef TIMER_H_
#define TIMER_H_

#if defined(__WIN32__)

#include<windows.h>

class Timer {	
  private:
	MMRESULT timerID;
	bool started;
  public:
  	Timer(void);
  	~Timer(void);
  	void Start(double period);
  	void Stop(void);
  private:
  	virtual void Execute(void)=0;
  	friend void CALLBACK TimerAuxFunc(UINT uID, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2);
};

#elif defined(__linux__)

#include<signal.h>
#include<time.h>

class Timer {
	struct sigevent evp;
  	timer_t tim;
  	struct itimerspec its;
  	bool started; 
  public:
  	Timer(void);
  	~Timer(void);
  	void Start(double period);
  	void Stop(void);
  private:
        virtual void Execute(void)=0;
        friend void TimerAuxFunc(sigval_t sigval);
};


#endif

#endif 
